<?php
class QuizModel extends Model
{
	public function Index()
	{
		$this->query('SELECT 
			q.id, 
			c.topic, 
			q.question, 
			IF(q.enabled = 1, "Yes", "No") AS enabled, 
			q.created_date, 
			q.modified_date
			FROM questions q
			JOIN topics c 
			ON c.id = q.topic 
			ORDER BY q.id');
		$rows = $this->resultSet();
		return $rows;
	}

	public function topic($topic, $question)
	{
		try
		{
			// Sanitize POST
			$post = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);
			// print_r($_GET);					
			if (isset($post['next']))
			{
				// Store answers into Session			
				$_SESSION["answers"][$post["question"]] = $post["answer"];
				$qry = "SELECT id FROM questions WHERE topic = :topic AND id > :question LIMIT 1";
				$this->query($qry);
				$this->bind(':topic', $topic);
				$this->bind(':question', $question);				
				$row = $this->single();
				if ($row)
				{
					$question = $row["id"];
					header('Location: '.ROOT_URL."quiz/topic/".$topic."/question/".$question);
				}
			}
			elseif (isset($post['submit']))
			{
				// Store answers into Session				
				$_SESSION["answers"][$post["question"]] = $post["answer"];
				$submitted = $_SESSION["answers"];
				// Marking answers
				$score = 0;
				$total = 0;
				foreach ($submitted as $question => $answer)
				{
					$cmd = "SELECT answer FROM questions WHERE topic = :topic and id = :id";
					$this->query($cmd);
					$this->bind(':topic', $topic);
					$this->bind(':id', $question);
					// echo "topic=".$topic."|question=".$question."|answer=".$answer."\r\n";
					$row = $this->single();
					if ($row)
					{
						if ($row["answer"] == $answer)
						{
							$score++;
						}
					}
					$total++;
				}
				$user_id = $_SESSION['user_data']['id'];
				// Find existing record and Insert/Update
				$qry = "SELECT";
				$qry .= " id";
				$qry .= " FROM results";
				$qry .= " WHERE topic = :topic";
				$qry .= " AND user = :user";
				$this->query($qry);
				$this->bind(':topic', $topic);
				$this->bind(':user', $user_id);
				$res = $this->single();
				if ($res)
				{
					$qry = "UPDATE results";
					$qry .= " SET score = :score,";
					$qry .= " modified_date = now()";
					$qry .= " WHERE topic = :topic";
					$qry .= " AND user = :user";
					$qry .= " AND id = :id";
					$this->query($qry);
					$this->bind(':score', $score."/".$total);
					$this->bind(':topic', $topic);
					$this->bind(':user', $user_id);
					$this->bind(':id', $res["id"]);
					$rows = $this->execute();					
				}
				else
				{
					$qry = "INSERT INTO results";
					$qry .= " (user, topic, score) VALUES";
					$qry .= " (:user, :topic, :score)";
					$this->query($qry);
					$this->bind(':user', $user_id);
					$this->bind(':topic', $topic);
					$this->bind(':score', $score."/".$total);
					$rows = $this->execute();					
				}
				// Reset session for answer
				$_SESSION["answers"] = array();
				header('Location: '.ROOT_URL);
			}
			else
			{
				// $question = null;
				// print_r($_GET);
				// $question = $post["qid"];
				if (empty($question) || $question == 0) 
					{
						$question = 0;
						$_SESSION["answers"] = array();
					}
				// $qry = "SELECT * FROM questions WHERE topic = :topic AND id > :question LIMIT 1";
				$qry = "SELECT q.id, (SELECT COUNT(id) FROM questions WHERE topic = :topic AND enabled = 1 AND id <= q.id) AS current, question, (SELECT COUNT(id) FROM questions WHERE topic = :topic AND enabled = 1) AS 'total' FROM questions q WHERE topic = :topic AND enabled = 1 AND id > :question LIMIT 1";			
				$this->query($qry);
				$this->bind(':topic', $topic);
				$this->bind(':question', $question);
				$row = $this->single();
				if ($row)
				{
					// header('Location: '.ROOT_URL."quiz/topic/".$topic."/question/".$qrow["id"]);

					$qry = "SELECT id, answer FROM answers WHERE enabled = 1 AND question = :question";
					$this->query($qry);
					$this->bind(':question', $row["id"]);
					$answers = $this->resultSet();

					$qry = "SELECT id FROM questions WHERE topic = :topic AND id > :id LIMIT 1";
					$this->query($qry);
					$this->bind(':topic', $topic);
					$this->bind(':id', $row["id"]);
					$hasmore = $this->single();
					$next = false;
					if ($hasmore)
					{
						$next = true;
					}
					$data = array('question' => $row, 'answers' => $answers, 'next' => $next);
					// echo '<br>';
					// print_r($data);
					return $data;
				}
				header('Location: '.ROOT_URL);
				return;
			}
		}
		catch (PDOException $e)
		{
			$msg_text = "[Exception] ".$e->getMessage();
			Messages::setMsg($msg_text, 'error');
			return;
		}		
	}

	public function add()
	{
		try 
		{
			// Sanitize POST
			$post = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);			
			if (isset($post['submit']))
			{
				if ($post['topic'] == '' || $post['question'] == '')
				{
					Messages::setMsg('Please Fill In All Fields', 'error');
					return $post;
				}
				// Insert into MySQL
				$this->query('INSERT INTO questions (topic, question) VALUES (:topic, :question)');
				$this->bind(':topic', $post['topic']);
				$this->bind(':question', $post['question']);
				$this->execute();
				// Verify
				if ($this->lastInsertId())
				{
					// Redirect
					header('Location: '.ROOT_URL.'questions');
				}
				else
				{
					Messages::setMsg('Cannot create question->' . $post['question'], 'error');
					return $post;
				}				
				return $post;
			}
			else
			{
				$this->query('SELECT id, topic FROM topics ORDER BY id');
				$viewmodel['topic_list'] = $this->resultSet();
				return $viewmodel;	
			}
		}
		catch (PDOException $e)
		{
			$msg_text = "[Exception] ".$e->getMessage();
			Messages::setMsg($msg_text, 'error');
			return;
		}		
	}

	public function edit($id)
	{
		try 
		{
			// Sanitize POST
			$post = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);			
			if (isset($post['submit']))
			{
				if ($post['topic'] == '' || $post['question'] == '')
				{
					Messages::setMsg('Please Fill In All Fields', 'error');
					return $post;
				}

				$topic = $post['topic'];				
				$question = htmlspecialchars($post['question']);
				$answer = $post['answer'];
				if (isset($post['enabled']) && $post['enabled'] == 1)
					$enabled = 1;					
				else 
					$enabled = 0;				
				// Insert into MySQL
				$this->query('UPDATE questions 
					SET 
					topic = :topic, 
					question = :question, 
					answer = :answer, 
					enabled = :enabled, 
					modified_date = now() 
					WHERE id = :id');
				$this->bind(':topic', $topic);
				$this->bind(':question', $question);
				$this->bind(':answer', $answer);
				$this->bind(':enabled', $enabled);
				$this->bind(':id', $id);
				$this->execute();
				// Redirect
				header('Location: '.ROOT_URL.'questions');
				// return;
			}
			else
			{
				$this->query('SELECT id, topic FROM topics ORDER BY id');
				$viewmodel['topic_list'] = $this->resultSet();

				$this->query('SELECT * FROM questions WHERE id = :id');
				$this->bind(':id', $id);
				$viewmodel['question_row'] = $this->single();

				$this->query('SELECT id, 
					answer, 
					IF(enabled = 1, "Yes", "No") AS enabled 
					FROM answers 
					WHERE question = :question');
				$this->bind(':question', $id);
				$viewmodel['answer_list'] = $this->resultSet();
				return $viewmodel;
			}
		}
		catch (PDOException $e)
		{
			$msg_text = "[Exception] ".$e->getMessage();
			Messages::setMsg($msg_text, 'error');
			return;
		}
	}
}