<?php
class UserModel extends Model
{
	public function register()
	{
		try
		{
			// Sanitize POST
			$post = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);			
			if (isset($post['submit']))
			{			
				if ($post['name'] == '' || $post['email'] == '' || $post['password'] == '')
				{
					Messages::setMsg('Please Fill In All Fields', 'error');
					return $post;
				}
				$name = $post['name'];
				$email = $post['email'];
				$password = md5($post['password']);

				// Check existing user name
				$this->query('SELECT id FROM users WHERE name = :name');
				$this->bind(':name', $name);
				$row = $this->single();
				if ($row)
				{
					Messages::setMsg('User name already exists', 'error');
					return $post;
				}
				// Insert into MySQL (default role = 'user')
				$qry = "INSERT INTO users";
				$qry .= " (name, email, password) VALUES";
				$qry .= " (:name, :email, :password)";
				$this->query($qry);
				$this->bind(':name', $name);
				$this->bind(':email', $email);
				$this->bind(':password', $password);
				$this->execute();
				// Verify
				if($this->lastInsertId())
				{
					// Redirect
					header('Location: '.ROOT_URL.'user/login');
				}
			}
			return;
		}
		catch (PDOException $e)
		{
			$msg_text = "[Exception] ".$e->getMessage();
			Messages::setMsg($msg_text, 'error');
			return $post;
		}
	}

	public function login()
	{
		try
		{
			// Sanitize POST
			$post = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);			
			if (isset($post['submit']))
			{
				if ($post['name'] == '' || $post['password'] == '')
				{
					Messages::setMsg('Please Fill In All Fields', 'error');
					return $post;
				}
				$password = md5($post['password']);
				// Compare Login
				$this->query('SELECT * FROM users WHERE name = :name AND password = :password');
				$this->bind(':name', $post['name']);
				$this->bind(':password', $password);
				$row = $this->single();

				if ($row)
				{
					$_SESSION['is_logged_in'] = 'frontend';
					$_SESSION['user_data'] = array(
						"id"	=> $row['id'],
						"name"	=> $row['name']
					);
					header('Location: '.ROOT_URL);
				} 
				else
				{
					Messages::setMsg('Incorrect Login', 'error');
					return $post;
				}
			}
			return;
		}
		catch (PDOException $e)
		{
			$msg_text = "[Exception] ".$e->getMessage();
			Messages::setMsg($msg_text, 'error');
			return $post;
		}			
	}
}